#ifndef proto_h_
#define proto_h_

#ifdef __STDC__
#define P(s) s
#else
#define P(s) ()
#endif

/* autokey.c */
int setAutoKeyOn P((void));
int setAutoKeyOff P((void));
void autoKeyDefaults P((void));
int doAutoKey P((void));
int autoKeyAllOff P((void));
int autoKeyOff P((W_Event * data));
int autoKeyTorpOn P((void));
int autoKeyTorpReqOn P((void));
int autoKeyPhaserOn P((void));
int autoKeyPhaserReqOn P((void));
int autoKeyDetOn P((void));
int autoKeyDetReqOn P((void));
int autoKeyPlasmaReqOn P((void));
int autoKeyBombReqOn P((void));
int autoKeyBeamUpReqOn P((void));
int autoKeyBeamDownReqOn P((void));
int autoKeyOrbitReqOn P((void));

/* blk_parsemotd.c */
void blk_parsemotd P((char *line));

/* colors.c */
void getColorDefs P((void));

/* data.c */

/* dashboard.c */
void stline P((int flag));
void redrawTstats P((void));
void light_send P((void));
void light_receive P((void));

/* death.c */
void death P((void));

/* defaults.c */
char   *initDefaults P((char *deffile));
char   *getdefault P((char *str));
char   *stringDefault P((char *str, char *preferred));
int strcmpi P((char *str1, char *str2));
int strncmpi P((char *str1, char *str2, int len));
int booleanDefault P((char *def, int preferred));
int intDefault P((char *def, int preferred));
int defaultShip P((int preferred));
void resetDefaults P((void));
char   *expandFilename P((char *));

/* detonate.c */
void detmine P((void));

/* dmessage.c */
void dmessage P((char *message, unsigned int flags, unsigned int from, unsigned int to));
void logit P((char *message));
void sendVersion P((void));

/* enter.c */
void enter P((void));
void openmem P((void));

/* findslot.c */
int findslot P((void));

/* getname.c */
void getname P((char *defname, char *defpasswd));

/* getship.c */
void init_shiptypes P((void));
struct ship *getship P((int s_type));
void init_galaxy_class P((void));

/* helpwin.c */
void fillhelp P((void));

/* inform.c */
void inform P((W_Window ww, int x, int y, int key));
void destroyInfo P((void));

/* input.c */
void initinput P((void));
void input P((void));
int getcourse P((W_Window ww, int x, int y));

/* interface.c */
void set_speed P((int speed));
void set_course P((unsigned int dir));
void shield_up P((void));
void shield_down P((void));
void shield_tog P((void));
void bomb_planet P((void));
void beam_up P((void));
void beam_down P((void));
void repair P((void));
void repair_off P((void));
void repeat_message P((void));
void cloak P((void));
void cloak_on P((void));
void cloak_off P((void));
int mtime P((void));

/* keymap.c */
void buildShipKeymap P((struct ship * shipp));
void initkeymap P((int type));
void keymapAdd P((char *str, char *map));
void ckeymapAdd P((char *cstr, char *map));
void buttonmapAdd P((char *str, char *map));
void cbuttonmapAdd P((char *cstr, char *map));
void dumpKeymap P((void));

/* main.c */
int main P((int argc, char **argv));
void reaper P((void));
unsigned long dotAddrToNetAddr P((char *str));

#ifdef MACROS
/* macros.c */
void doMacro P((W_Event * data));

/* macrowin.c */
void showMacroWin P((void));
#endif				/* MACROS */

/* newwin.c */
void newwin P((char *hostmon, char *progname));
void mapAll P((void));
void entrywindow P((int *team, int *s_type));
int deadTeam P((int owner));
void erase_motd P((void));
void newMotdPic P((int x, int y, int width, int height, char *bits, int page));
void newMotdLine P((char *line));
void fillhelp P((void));
void drawIcon P((void));
void do_refit P((int type));
void showMotd P((W_Window win));

/* option.c */
void optionwindow P((void));
void optionredrawtarget P((W_Window win));
void optionredrawoption P((int *ip));
int optionaction P((W_Event * data));
void optiondone P((void));

#ifdef METASERVER
/* parsemeta.c */
void parsemeta P((void));
void metawindow P((void));
void metainput P((void));
void metaaction P((W_Event * data));
#endif				/* METASERVER */

/* planetlist.c */
void planetlist P((void));

/* planets.c */
void initPlanets P((void));
void checkRedraw P((int x, int y));
void initStars P((void));
void drawStars P((void));
void clearStars P((void));

/* playerlist.c */
void playerlist P((void));
void playerlist2 P((void));
struct player;
char   *get_players_rank_name P((struct player * j));
void selectblkbozo P((W_Event * data));
void playerwEvent P((W_Event * data));

/* ranklist.c */
void ranklist P((void));

/* ratings.c */
struct ratings *get_ratings P((struct player * s, struct ratings * r));

/* redraw.c */
struct _clearzone *new_czone P((void));

/* reserved.c */
int makeReservedPacket P((void *packet));
int encryptReservedPacket P((void *spacket, void *cpacket, char *server, int pno));

/* sintab.c */
void inittrigtables P((void));

/* smessage.c */
void message_expose P((void));
void smessage P((int ichar));
void smessage_ahead P((int head, int ichar));
void pmessage P((char *str, int recip, int group));
void emergency P((void));
void carry_report P((void));
void message_on P((void));
void message_off P((void));
void sendCharMessage P((char *buf, int ch));

/* socket.c */
void print_totals P((void));
void connectToServer P((int port));
void callServer P((int port, char *server));
int isServerDead P((void));
void socketPause P((int sec, int usec));
int readFromServer P((void));
int readFromServer P((void));
void sendShortPacket P((int type, int state));
void sendTeamReq P((int team, int ship));
void sendLoginReq P((char *name, char *pass, char *login, int query));
void sendTractorReq P((int state, int pnum));
void sendRepressReq P((int state, int pnum));
void sendDetMineReq P((int torp));
void sendMessage P((char *mes, int group, int indiv));
void sendOptionsPacket P((void));
void sendUpdatePacket P((long speed));
void sendUdpReq P((int req));
int closeUdpConn P((void));
short swaps P((int in));

/* stats.c */
void redrawStats P((void));
void updateStats P((void));
void calibrate_stats P((void));

/* udpopt.c */
void udpwindow P((void));
void udprefresh P((int i));
void udpaction P((W_Event * data));
void udpdone P((void));

/* util.c */
int angdist P((unsigned int x, unsigned int y));
struct obtype *gettarget P((W_Window ww, int x, int y, int targtype));
struct id *getTargetID P((W_Window ww, int x, int y, int targtype));
char   *team_bit_string P((int mask));
#if !defined(apollo) && !defined(SVR4) && !defined(linux) && !defined(AMIGA) && !defined(sgi) && !defined(__FreeBSD__)
int srandom P((int foo));
#endif

#if !defined(linux) && !defined(SVR4) && !defined(AMIGA) && !defined(__FreeBSD__)
#ifdef sgi
long
#else
int
#endif
random  P((void));
#endif

/* varydamage.c */
struct ship_shape;
void doShields P((int dx, int dy, struct ship_shape * ship_bits, struct player * j));
void doHull P((int dx, int dy, struct ship_shape * ship_bits, struct player * j));

/* war.c */
void warwindow P((void));
void waraction P((W_Event * data));

/* warning.c */
void warning P((char *text));
char   *timeString P((time_t time));

/* wide_plist.c */
void wideplayerlist P((void));
void wideplayerlist2 P((void));

/* x11window.c */
int checkMapped P((char *window));
void W_RenameWindow P((W_Window window, char *str));
void W_GetEvent P((W_Event * wevent));

#ifdef RECORDER
/* recorder.c */
void startRecorder P((void));
void stopRecorder P((void));
void recordPacket P((char *data, int len));
void writeUpdateMarker P((void));
int startPlayback P((void));
int readRecorded P((int fp, char *data, int len));
#endif

#ifdef XTREKRC_HELP
/* defwin.c */
void showdef P((void));
void def_action P((W_Event *ev));
#endif

#endif
